#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	LL a, b, k;
	cin >> a >> b >> k;
	
	vector<LL> cubes;
	
	for (int i = 1; i <= (int)1e6; ++i) {
		long long j = i * 1ll * i * i;
		if (a <= j && j <= b) cubes.push_back(j);
	}
	
	long long ans = 0;
	
	for (auto c : cubes) {
		LOG("c %I64d", c);
		long long L = max(a, c - k);
		long long R = min(b, c + k);
		
		long long Ls = sqrt(L);
		if (Ls * Ls < L)
			Ls++;
		
		long long Rs = sqrt(R);
		
		LOG(" Ls %I64d Rs %I64d\n", Ls, Rs);
		
		ans += max(0ll, Rs - Ls + 1);
	}
	
	cout << ans << endl;
	
	return 0;
}