#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

typedef long long LL;

const LL INF = (LL)1e7;
const int MAXN = 200005;

int n, m;
vector<int> g[MAXN];

int maxdepth = 0;

void dfsmdepth(int v, int depth) {
	maxdepth = max(maxdepth, depth);
	
	for (auto to : g[v]) {
		dfsmdepth(to, depth + 1);
	}
}

LL ans = 1;

LL dfsdp(int v) {
	if (g[v].size() == 0) {
		return 1 + (m - 1) * 1ll * maxdepth;
	}
	
	vector<LL> sons;
	sons.reserve(g[v].size());
	for (auto to : g[v]) {
		sons.push_back(dfsdp(to));
	}
	
	sort(sons.begin(), sons.end(), greater<LL>());
	
	if (sons.size() > 1)
		ans = max(ans, sons[0] + 1 + sons[1]);
	
	return sons[0] + 1;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	cin >> n >> m;
	
	for (int i = 2; i <= n; ++i) {
		int p;
		cin >> p;
		g[p].push_back(i);
	}
	
	dfsmdepth(1, 1);
	
	dfsdp(1);
	
	cout << ans << endl;
	
	return 0;
}