#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

typedef long long LL;

int k, n, m;

map<int, int> vals;

int calc(int level, int pos, int cv) {
	LOG("level %d pos %d cv %d\n", level, pos, cv);
	
	auto itL = vals.lower_bound(pos);
	auto itR = vals.lower_bound(pos + (1 << level) - 1);
	
	LOG("itL %d -> %d\n", itL->first, itL->second);
	LOG("itR %d -> %d\n", itR->first, itR->second);
	
	unordered_set<int> have;
	do {
		have.insert(itL->second);
		if (itL != itR) itL++;
		else break;
	} while (1);
	
#ifdef _DEBUG
	LOG("have: ");
	for (auto nv : have)
		LOG("%d ", nv);
	LOG("\n\n");
#endif
	
	if (have.size() == 1) {
		return *have.begin() != cv;
	}
	
	int mn = (int)1e9;
	
	for (auto nv : have) {
		int cur = nv != cv;
		cur += calc(level - 1, pos, nv);
		cur += calc(level - 1, pos + (1 << (level - 1)), nv);
		mn = min(mn, cur);
	}
	
	return mn;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	cin >> k >> n >> m;
	
	int pos = -1;
	
	for (int i = 0; i < n; ++i) {
		int c, v;
		cin >> c >> v;
		pos += c;
		vals[pos] = v;
	}
	
#ifdef _DEBUG
	LOG("vals:\n");
	for (auto p : vals)
		LOG("%d -> %d\n", p.first, p.second);
	LOG("\n");
#endif
	
	cout << calc(k, 0, 0) << endl;
	
	return 0;
}