#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

typedef long long LL;

int k, n, m;

map<int, int> vals;

pair<int, set<int>> calc(int level, int pos) {
	auto itL = vals.lower_bound(pos);
	auto itR = vals.lower_bound(pos + (1 << level) - 1);
	
	set<int> have;
	for (;;) {
		have.insert(itL->second);
		if (itL != itR) itL++;
		else break;
	}
	
	if (have.size() == 1) {
		return pair<int, set<int>>{0, have};
	}
	
	pair<int, set<int>> L = calc(level - 1, pos);
	pair<int, set<int>> R = calc(level - 1, pos + (1 << (level - 1)));
	
	if (L.second.size() > R.second.size()) swap(L, R);
	
	set<int> res;
	
	for (auto it : L.second)
		if (R.second.count(it)) res.insert(it);
	
	if (!res.empty()) {
		return pair<int, set<int>>{L.first + R.first, res};
	}
	
	int mnd = L.first + R.first + 1;
	
	for (auto it : L.second)
		res.insert(it);
	for (auto it : R.second)
		res.insert(it);
	
	return pair<int, set<int>>{mnd, res};
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	cin >> k >> n >> m;
	
	int pos = -1;
	
	for (int i = 0; i < n; ++i) {
		int c, v;
		cin >> c >> v;
		pos += c;
		vals[pos] = v;
	}
	
	auto res = calc(k, 0);
	
	cout << res.first + 1 << endl;
	
	return 0;
}