#include <bits/stdc++.h>

using namespace std;

typedef long long LL;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

int main() {
#ifdef _DEBUG
  freopen("input.txt", "r", stdin);
  freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	int n, m;
	cin >> n >> m;

	struct Person {
		LL time;
		int floor;
		int id;
		
		bool operator<(const Person &o) const {
			return time != o.time ? time < o.time : id < o.id;
		}
	};
	
	vector<Person> a(n);
	
	for (int i = 0; i < n; ++i) {
		cin >> a[i].time >> a[i].floor;
		a[i].id = i;
	}
	
	sort(a.begin(), a.end());
	
	int itdone = 0, itcome = 0; // itcome >= itdone
	
	map<int, vector<int>> q;
	vector<LL> ans(n, -1);

	int targetf = 1, curf = 1;
	bool active = 0, down = 0;
	LL timer = 0;
	
	vector<int> inside;
	inside.reserve(n);
	
	while (itdone != n) {
		while (itdone < n && ans[a[itdone].id] != -1) itdone++;
		while (itcome < n && a[itcome].time <= timer) {
			q[a[itcome].floor].push_back(a[itcome].id);
			itcome++;
		}
		if (itdone == n) break;
		
		if (active) {
			if (down) {
				if (q.count(curf)) {
					inside.insert(inside.end(), q[curf].begin(), q[curf].end());
					q.erase(curf);
				}
					
				if (curf == 1) {
					down = 0;
					active = 0;
					for (auto x : inside) {
						ans[x] = timer;
					}
					inside.clear();
				}
				else {	
					
					auto it = q.lower_bound(curf);
					
					LL delta = curf - 1;
					
					if (it != q.begin()) {
						--it;
						delta = curf - it->first;
					}
					
					if (itcome < n)
						delta = min(delta, a[itcome].time - timer);
					
					
					timer += delta;
					curf -= delta;
				}
			} else {		
				LL delta = targetf - curf;
				timer += delta;
				curf = targetf;
				down = 1;
			}
		} else {
			if (itcome == itdone) {
				timer = a[itcome].time;		
			} else {
				active = 1;
				down = 0;
				targetf = a[itdone].floor;
			}
		}
	}
	
	for (int i = 0; i < n; ++i)
		cout << ans[i] << '\n';
	
	return 0;
}