#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

typedef long long LL;

const LL INF = (LL)1e7;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	LL k, s;
	cin >> k >> s;
	
	for (LL a = k; ; a++) {
		LL left = 0, right = INF;
		
		while (right - left > 1) {
			LL mid = (left + right) / 2;
			LL smax = a * mid + mid * (mid + 1) / 2;
			if (smax >= s)
				right = mid;
			else
				left = mid;
		}
		
		LL b = right;
		
		if (k * b + b * (b + 1) / 2 <= s) {
			cout << a << endl;
			return 0;
		}
	}
	
	return 0;
}