#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

typedef long long LL;

const LL INF = (LL)1e7;

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	LL k, s;
	cin >> k >> s;
	
	LL left = 0, right = INF;
		
	while (right - left > 1) {
		LL mid = (left + right) / 2;
		LL smin = k * mid + mid * (mid + 1) / 2;
		if (smin <= s)
			left = mid;
		else
			right = mid;
	}
	
	LL b = left;
	
	cout << (s - b * (b + 1) / 2 + b - 1) / b << endl;
	
	return 0;
}