#include <bits/stdc++.h>
using namespace std;

#ifdef _DEBUG
# define LOG(x...) fprintf(stderr, x)
#else
# define LOG(x...) 0
#endif

typedef long long LL;

int k, n, m;

map<int, int> vals;

map<int, int> calc(int level, int pos) {
	assert(level >= 0);
	LOG("level %d pos %d\n", level, pos);
	
	auto itL = vals.lower_bound(pos);
	auto itR = vals.lower_bound(pos + (1 << level) - 1);
	
	LOG("itL %d -> %d\n", itL->first, itL->second);
	LOG("itR %d -> %d\n", itR->first, itR->second);
	
	unordered_set<int> have;
	for (;;) {
		have.insert(itL->second);
		if (itL != itR) itL++;
		else break;
	}
	
#ifdef _DEBUG
	LOG("have: ");
	for (auto nv : have)
		LOG("%d ", nv);
	LOG("\n\n");
#endif
	
	if (have.size() == 1) {
		map<int, int> res;
		res[*have.begin()] = 0;
		return res;
	}
	
	map<int, int> L = calc(level - 1, pos);
	map<int, int> R = calc(level - 1, pos + (1 << (level - 1)));
	
	int mnL = L.begin()->second, mnR = R.begin()->second;
	
	for (auto xl : L)
		mnL = min(mnL, xl.second);
	for (auto xr : R)
		mnR = min(mnR, xr.second);
	
	map<int, int> res;
	
	for (auto setc : have) {
		res[setc] = (L.count(setc) ? L[setc] : mnL + 1) + (R.count(setc) ? R[setc] : mnR + 1);
	}
	
	return res;
}

int main() {
#ifdef _DEBUG
	freopen("input.txt", "r", stdin);
	freopen("output.txt", "w", stdout);
#endif
	cin.tie(0);
	cin.sync_with_stdio(0);

	cin >> k >> n >> m;
	
	int pos = -1;
	
	for (int i = 0; i < n; ++i) {
		int c, v;
		cin >> c >> v;
		pos += c;
		vals[pos] = v;
	}
	
#ifdef _DEBUG
	LOG("vals:\n");
	for (auto p : vals)
		LOG("%d -> %d\n", p.first, p.second);
	LOG("\n");
#endif
	
	map<int, int> res = calc(k, 0);
	int mn = res.begin()->second;
	for (auto xr : res)
		mn = min(mn, xr.second);
	
	cout << mn + 1 << endl;
	
	return 0;
}